﻿Imports System.Net
Imports System.IO

Public Class Form1

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        SendMessage(txtApi.Text, txtTo.Text, txtMsg.Text)
    End Sub

    Public Sub SendMessage(ByVal Token As String, ByVal userName As String, ByVal message As String)
        If String.IsNullOrEmpty(Token) Then
            Throw New InvalidOperationException("You must set the Token property before calling the SendMessage method.")
        End If
        If String.IsNullOrEmpty(userName) Then
            Throw New InvalidOperationException("You must set the RoomId property before calling the SendMessage method.")
        End If
        If String.IsNullOrEmpty(message) Then
            Throw New ArgumentException("You cannot send a blank message.", "message")
        End If
        If message.Length > 5000 Then message = message.Substring(0, 4997) + "..."

        Dim httpWebRequest = WebRequest.Create(String.Format("https://api.hipchat.com/v2/user/@{1}/message?auth_token={0}", Token, userName))
        httpWebRequest.ContentType = "application/json"
        httpWebRequest.Method = "POST"

        Using streamWriter = New StreamWriter(httpWebRequest.GetRequestStream())
            Dim json As String = "{""message"":""" + message + """}"
            streamWriter.Write(json)
            streamWriter.Flush()
            streamWriter.Close()
            httpWebRequest.GetResponse()
        End Using

    End Sub

    Private Sub LinkLabel1_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        Dim sInfo As New ProcessStartInfo(e.Link.LinkData.ToString())
        Process.Start(sInfo)
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        LinkLabel1.Links.Add(0, LinkLabel1.Text.Length, "http://hipchat.com/account/api")
    End Sub
End Class
